package net.jaekl.cfb.xml;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import net.jaekl.qd.xml.ParseResult;
import net.jaekl.qd.xml.XmlParseException;

public class BugCollection extends ParseResult {

	static final String TAG = "BugCollection";
	static final String[] INTERNAL = { };
	static final Object[][] EXTERNAL = { { BugInstance.TAG, BugInstance.class} };

	ArrayList<BugInstance> m_bugs;
	
	public BugCollection() {
		super(TAG, INTERNAL, EXTERNAL);
		m_bugs = new ArrayList<BugInstance>();
	}
	
	public List<BugInstance> getBugs() { return Collections.unmodifiableList(m_bugs); }
	public void add(BugInstance bug) { m_bugs.add(bug); }
	
	@Override
	public void endContents(String uri, String localName, String qName,	String chars) 
		throws XmlParseException 
	{
		// no-op
	}

	@Override
	public void endExternal(String uri, String localName, String qName)
		throws XmlParseException 
	{
		if (BugInstance.TAG.equals(localName)) {
			ParseResult[] collected = collectParsedChildren(BugInstance.class);
			for (ParseResult pr : collected) {
				assert(pr instanceof BugInstance);
				m_bugs.add((BugInstance) pr);
			}
		}
	}
	
	@Override
	public void dump(PrintWriter pw, int indent) {
		super.dump(pw, indent);
		for (BugInstance bug : m_bugs) {
			bug.dump(pw, indent + 2);
		}
	}

}
